<!DOCTYPE html>
<html lang="en">
<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Danh sách người dùng</h2>
  
  <table id="user-table" class="table table-bordered table-striped table-hover">
    <thead>
      <tr>
        <th>Mã người dùng</th>
        <th>Firstname</th>
        <th>Lastname</th>
        <th>Age</th>
        <th>Action</th>
      </tr>
    </thead>
    <tbody>
      
    </tbody>
  </table>
</div>
​<script>
  $(document).ready(function() {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gJsonUser = `{
      "description": "Data user",
      "users": [
        {
          "userId": 1,
          "firstname": "Test1",
          "lastname": "User1",
          "age": 18
        },
        {
          "userId": 2,
          "firstname": "Test2",
          "lastname": "User2",
          "age": 19
        },
        {
          "userId": 3,
          "firstname": "Test3",
          "lastname": "User3",
          "age": 18
        },
        {
          "userId": 4,
          "firstname": "Test4",
          "lastname": "User4",
          "age": 20
        },
        {
          "userId": 5,
          "firstname": "Test5",
          "lastname": "User5",
          "age": 21
        },
        {
          "userId": 6,
          "firstname": "Test6",
          "lastname": "User6",
          "age": 20
        }
      ]
    }`;

    var gListUsers = JSON.parse(gJsonUser); //array user, dữ liêu từ json ra 
    console.log(gListUsers);
    var gNameCol = ["userId", "firstname", "lastname", "age", "action"]; //gán với tên các cột trong array
    const gUSER_ID_COL = 0;
    const gFIRST_NAME_COL = 1;
    const gLAST_NAME_COL = 2;
    const gAGE_COL = 3;
    const gACTION_COL = 4;
    
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();
    $(document).on("click", "#user-table .btn-detail", function(){
      onBtnDetailClick(this);
    })
    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      /* add JSON data vào DataTable sử dụng add trực tiếp DataTable row */
      $("#user-table").DataTable({
        columns: [
          {data: gNameCol[gUSER_ID_COL]},
          {data: gNameCol[gFIRST_NAME_COL]},
          {data: gNameCol[gLAST_NAME_COL]},
          {data: gNameCol[gAGE_COL]},
          {data: gNameCol[gACTION_COL]},
        ],
        columnDefs:[  //định nghĩa các cột cần hiện ra
          {
            targets: gUSER_ID_COL, //cột id
            className: "text-right text-primary"
          }, 
          {
            targets: gAGE_COL, // cột tuổi
            className: "text-right"
          }, 
          {
            targets: gACTION_COL, //cột action
            className: "text-left",
            defaultContent: "<button class ='btn btn-primary btn-detail'>Chi tiết</button>" //nội dung của côt action là nút chi tiết
          }
        ]
      });
      insertRowToTable();
      
    }

    //hàm thêm từng dòng dữ liêu vào datatable
    function insertRowToTable(){
      "use strict"
      var vTable = $("#user-table").DataTable();
      vTable.rows.add(gListUsers.users);
      vTable.draw();
    }

    function onBtnDetailClick(paramEle){
      "use strict"
      var vRowClick = $(paramEle).closest("tr"); //xác định tr chứa nứt bấm click
      var vTable = $("#user-table").DataTable(); //tạo biến truy cập đến datatable
      var vDataRow = vTable.row(vRowClick).data(); //lấy dữ liệu của hangf dữ liêu chứa nút click
      console.log(vDataRow);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    
  });
  
</script>
</body>
</html>
​
